// 3DView.cpp : implementation file
//

#include "stdafx.h"
#include "math.h"
#include "ebdlib3.h"
#include "3DView.h"
#include "SetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// C3DView

IMPLEMENT_DYNCREATE(C3DView, CView)

C3DView::C3DView()
    : CStandardView()
{
	 m_a = 0.2;
	 m_b = 0.8;
	 m_c = 0.2;  

	 m_x = 0.0;
	 m_y = 1.0;
	 m_z = -4.0;

	 m_xa = 45.0; 
     m_ya = 0.0; 
	 m_za = 0.0; 

	 m_Color1[0] = 255;
	 m_Color1[1] = 10;
	 m_Color1[2] = 10;
	 m_Color1[3] = 255;
	 m_Color2[0] = 100;
	 m_Color2[1] = 255;
	 m_Color2[2] = 255;
	 m_Color2[3] = 0;

	 m_iCounter = 0;

	 m_bTimer = FALSE;
	 m_bActive = TRUE;

	 m_iInit = FALSE;
	 IDD = ID_3D;
}

C3DView::~C3DView()
{
}


BEGIN_MESSAGE_MAP(C3DView, CView)
	//{{AFX_MSG_MAP(C3DView)
	ON_COMMAND(IDM_3DEXIT, On3dexit)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// C3DView drawing

void C3DView::OnDraw(CDC* pDC)
{
	CStandardDoc* pDoc = GetDocument();
	// TODO: add draw code here
	if(!m_iInit)
	{
	    SetupEnv();
	    Build3Ddata();
	}

	if(m_hPalette)
    {
		SelectPalette(pDC->m_hDC, m_hPalette, FALSE);
		RealizePalette(pDC->m_hDC);
    }


	wglMakeCurrent(m_hDC, m_hRC);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	Draw3DObject();
	glFlush();
	SwapBuffers(m_hDC);
    wglMakeCurrent(m_hDC, NULL); 
}

/////////////////////////////////////////////////////////////////////////////
// C3DView diagnostics

#ifdef _DEBUG
void C3DView::AssertValid() const
{
	CView::AssertValid();
}

void C3DView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// C3DView message handlers

void C3DView::On3dexit() 
{
	// TODO: Add your command handler code here
	GetParent()->SendMessage(WM_CLOSE);	

}

void C3DView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
   
	if(pHint == NULL)
		return;
	
	

	WNDINFO* info = (WNDINFO *)pHint;

	if(info->m_iID == (int)IDD && info->m_iPin == m_iPin)
	{
	    if(lHint == UPDATE_ONE)
		{	
           CSetDlg dlg(this);
		   BOOL  isTimer = m_bTimer;

		   dlg.m_bAnimation = m_bActive;
		   memcpy(dlg.m_Color1, m_Color1, 4*sizeof(BYTE));
		   memcpy(dlg.m_Color2, m_Color2, 4*sizeof(BYTE));
		   if(dlg.DoModal() == IDOK)
		   {
		       m_bTimer = dlg.m_bAnimation;
		       memcpy(m_Color1, dlg.m_Color1, 4*sizeof(BYTE));
		       memcpy(m_Color2, dlg.m_Color2, 4*sizeof(BYTE));
			   if((!m_bTimer) && isTimer)
			   {
		           KillTimer(m_iTimer);
				   m_bActive = FALSE;
			   }
			   else if(m_bTimer && (!isTimer))
			   {
	               SetTimer(m_iTimer, 1, NULL);
				   m_bActive = TRUE;
			   }
		       
	           Build3Ddata();

               Invalidate(FALSE);
		   }
		}
	}
	
	
}

int C3DView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
    PIXELFORMATDESCRIPTOR pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,
		PFD_DRAW_TO_WINDOW|
		PFD_SUPPORT_OPENGL|
		PFD_DOUBLEBUFFER,  
		PFD_TYPE_RGBA,
		24,
		0,0,0,0,0,0,
        0,0,0,0,0,0,0,
		32,
		0,0,
		PFD_MAIN_PLANE,
		0,
		0,0,0
	};
     
	m_hDC = ::GetDC(m_hWnd);			// Get the Device context
	
	int pixelFormat =
		ChoosePixelFormat(m_hDC, &pfd);
	BOOL success = 
		SetPixelFormat(m_hDC, pixelFormat, &pfd);

	DescribePixelFormat(m_hDC, pixelFormat,
		  sizeof(pfd), &pfd);

	if(pfd.dwFlags & PFD_NEED_PALETTE)
		SetupLogicalPalette();

	m_iTimer = ((CChildFrame*)GetParent())->GetIndex();

	SetTimer(m_iTimer, 1, NULL);
	m_bTimer = TRUE;
	m_bActive = TRUE;
	
	m_hRC = wglCreateContext(m_hDC);

	wglMakeCurrent(m_hDC, m_hRC);
	
	SetupEnv();
	Build3Ddata();

    m_iInit = TRUE;
	
	Invalidate(TRUE);
	
	return 0;
}

void C3DView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_iCounter < 10)
	{
	   m_a += 0.06;
	   m_b -= 0.06;
	   m_c += 0.06;  

	   m_y -= 0.2;
	}
	else
	{
	   m_a -= 0.06;
	   m_b += 0.06;
	   m_c -= 0.06;  

	   m_y += 0.2;
	}

	m_iCounter ++;

	if(m_iCounter >= 20)
		m_iCounter = 0;

	Build3Ddata();
	Invalidate(FALSE);
	
	CView::OnTimer(nIDEvent);
}

void C3DView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	wglMakeCurrent(m_hDC, m_hRC);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-1.0, 1.0, -1.0, 1.0, 2.0, 7.0);
	glViewport(0, 0, cx, cy);
	wglMakeCurrent(NULL, NULL);

	Invalidate(TRUE);
}

BOOL C3DView::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(m_bTimer)
		KillTimer(m_iTimer);
	
	
	wglDeleteContext(m_hRC);
	
	if(m_hPalette)
       DeleteObject(m_hPalette);
	::ReleaseDC(m_hWnd, m_hDC);


	return CView::DestroyWindow();
}


void C3DView::SetupLogicalPalette(void)
{
/*    struct
	{
		WORD palVersion;
		WORD palNumEntries;
		PALETTEENTRY palPalEntry[256];
	}logicalPalette = {0x300, 256};
	
	BYTE reds[] = {0, 36, 72, 109, 145, 182, 218, 255};
	BYTE greens[] = {0, 36, 72, 109, 145, 182, 218, 255};
	BYTE blues[] = {0, 85, 170, 255};

	for(int colorNum = 0; colorNum < 256; ++colorNum)
	{
		logicalPalette.palPalEntry[colorNum].peRed
			= reds[colorNum & 0x07];
		logicalPalette.palPalEntry[colorNum].peGreen
			= greens[(colorNum>>0x03) & 0x07];
		logicalPalette.palPalEntry[colorNum].peBlue
			= blues[(colorNum>>0x06) & 0x07];
		logicalPalette.palPalEntry[colorNum].peFlags = 0;
	}

	m_hPalette = CreatePalette((LOGPALETTE*)&logicalPalette);
*/
	PIXELFORMATDESCRIPTOR pfd;  // Pixel Format Descriptor         
	LOGPALETTE *pPal;			// Pointer to memory for logical palette
	int PixelFormat;			// Pixel format index
    int paletteSize;            // Number of entries in palette 
	BYTE RedMask;               // Range for each color entry (7,7,and 3)
	BYTE GreenMask;
	BYTE BlueMask;
								

	// Get the pixel format index and retrieve the pixel format description
    PixelFormat = GetPixelFormat(m_hDC);
    DescribePixelFormat(m_hDC, PixelFormat, sizeof(PIXELFORMATDESCRIPTOR), &pfd);
    
	
	// Check whether the pixel format and the pixel type
	if (!(pfd.dwFlags & PFD_NEED_PALETTE ||
	  pfd.iPixelType == PFD_TYPE_COLORINDEX))
	    return;

	// Get the number of entries in palette. 256 colors for 8 bits 
    paletteSize = 1 << pfd.cColorBits;
    
	// Allocate for the logical palette
	pPal = (LOGPALETTE*)
	malloc(sizeof(LOGPALETTE) + paletteSize * sizeof(PALETTEENTRY));
    
	
	// Fill the logical palette header information 
	pPal->palVersion = 0x300;            //support Windows3.0
    pPal->palNumEntries = paletteSize;   //number of colors entries

    // Set the 1st entries of logical palette with the current system palette 
    (void) GetSystemPaletteEntries(m_hDC, 0, paletteSize, &pPal->palPalEntry[0]);

	//Set the RGB mask
	RedMask = (1 << pfd.cRedBits) - 1;
	GreenMask = (1 << pfd.cGreenBits) - 1;
	BlueMask = (1 << pfd.cBlueBits) - 1;

	//Set all entries of the logical palette 
    for (int i=0; i<paletteSize; ++i) 
	{
	    pPal->palPalEntry[i].peRed =
		    (((i >> pfd.cRedShift) & RedMask) * 255) / RedMask;
	    pPal->palPalEntry[i].peGreen =
		    (((i >> pfd.cGreenShift) & GreenMask) * 255) / GreenMask;
	    pPal->palPalEntry[i].peBlue =
		    (((i >> pfd.cBlueShift) & BlueMask) * 255) / BlueMask;
	    pPal->palPalEntry[i].peFlags = 0;
    }

	//Create the palette
    m_hPalette = CreatePalette(pPal);

	//If success, select and realize the palette for this device context
    if(m_hPalette) 
	{
	    SelectPalette(m_hDC, m_hPalette, FALSE);
	    RealizePalette(m_hDC);
    }

	//Free the memory allocated for the logical palette 
    free(pPal);

}


void C3DView::SetupEnv(void)
{
    float fv4[4];
    int iv1[1];
    int i;
    GLint dlBase;

    
    glClearColor(1.0, 1.0, 1.0, 1.0);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	fv4[0] = 0.05f;
    fv4[1] = 0.05f;
    fv4[2] = 0.05f;
    fv4[3] = 1.0f;
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, fv4);
    
    fv4[0] = 0.1f;
    fv4[1] = 0.1f;
    fv4[2] = 0.1f;
    fv4[3] = 0.1f;
    glLightfv(GL_LIGHT0, GL_AMBIENT, fv4);
    
	fv4[0] = 90.0f;
    fv4[1] = 90.0f;
    fv4[2] = 100.0f;
    fv4[3] = 100.0f;
    glLightfv(GL_LIGHT0, GL_POSITION, fv4);
    
	fv4[0] = 0.5f;
    fv4[1] = 1.0f;
    fv4[2] = 1.0f;
    fv4[3] = 1.0f;
    glLightfv(GL_LIGHT0, GL_DIFFUSE, fv4);
    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHTING);

    fv4[0] = 0.6f;
    fv4[1] = 0.6f;
    fv4[2] = 1.6f;
    fv4[3] = 1.0f;
    glMaterialfv(GL_FRONT, GL_SPECULAR, fv4);

    fv4[0] = 0.6f;
    fv4[1] = 0.1f;
    fv4[2] = 0.1f;
    fv4[3] = 1.0f;
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, fv4);
    

	iv1[0] = 60.0;
    glMaterialiv(GL_FRONT_AND_BACK, GL_SHININESS, iv1);
  
    
    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_NORMAL_ARRAY);
    glEnableClientState(GL_COLOR_ARRAY);
    
    glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
    glEnable(GL_COLOR_MATERIAL);

}

void C3DView::Build3Ddata(void)
{
    float dTemp;             
    float dDTheta, dRotate;
	float dSin, dCos;
    float dX, dY, dZ;
	float dE, dT, dL, dNX, dNY, dNZ;  
    float dA, dB, dC;  
  	

	int  i, j, m, k, l;               


    dT = (float)2*m_b/ROW;
	dRotate = 2.0 * PI /COL;
    dA = m_a*m_a;
	dB = m_b*m_b;
	dC = m_c*m_c;


    for(k = 0; k <= COL; k++)
    {
		m_Point[k].m_vPoint[0] = 0.0;
		m_Point[k].m_vPoint[1] = -1.0*m_b;
		m_Point[k].m_vPoint[2] = 0.0;

		m_Point[k].m_vNormal[0] = 0.0;
		m_Point[k].m_vNormal[1] = -1.0;
		m_Point[k].m_vNormal[2] = 0.0;


		l = ROW * (COL+1) + k;

		m_Point[l].m_vPoint[0] = 0.0;
		m_Point[l].m_vPoint[1] = m_b;
		m_Point[l].m_vPoint[2] = 0.0;

		m_Point[l].m_vNormal[0] = 0.0;
		m_Point[l].m_vNormal[1] = 1.0;
		m_Point[l].m_vNormal[2] = 0.0;
	}

	for(i = 1; i < ROW; i++)
	{
	   dY = dT * i - m_b;
       dTemp = (dY*dY / dB); 
	   for(j = 0; j <= COL; j++)
	   {
		   k = i * (COL+1) + j;
		   
		   //calculate vertex
		   dDTheta = j * dRotate;
		   dSin = sin(dDTheta);
		   dCos = cos(dDTheta);
		   dL = (dCos*dCos)/dA + (dSin*dSin)/dC; 
		   dE = sqrt((1 - dTemp)/dL);
		   dX = dE*dCos;
		   dZ = dE*dSin;
           
		   m_Point[k].m_vPoint[0] = dX;
		   m_Point[k].m_vPoint[1] = dY;
		   m_Point[k].m_vPoint[2] = dZ;
           
		   //calculate normal
		   dNX = 2.0 * dX / dA;
		   dNY = 2.0 * dY / dB;
		   dNZ = 2.0 * dZ / dC;
           
		   dL = (float)sqrt(dNX*dNX + dNY*dNY + dNZ*dNZ);
		   dNX /= dL;
		   dNY /= dL;
		   dNZ /= dL;

		   m_Point[k].m_vNormal[0] = dNX;
		   m_Point[k].m_vNormal[1] = dNY;
		   m_Point[k].m_vNormal[2] = dNZ;
		   
	   }
	}
	
    for(i = 0; i < ROW; i++)
	{
	   for(j = 0; j < COL; j++)
	   {
	      k = i * COL + j;
		  if(((i/5)%2)^((j/5)%2)) 		  
		  {
             m_Vertex[k].m_vColor[0] = m_Color1[0];
             m_Vertex[k].m_vColor[1] = m_Color1[1];
             m_Vertex[k].m_vColor[2] = m_Color1[2];
             m_Vertex[k].m_vColor[3] = m_Color1[3];
		  }
		  else
		  {
             m_Vertex[k].m_vColor[0] = m_Color2[0];
             m_Vertex[k].m_vColor[1] = m_Color2[1];
             m_Vertex[k].m_vColor[2] = m_Color2[2];
             m_Vertex[k].m_vColor[3] = m_Color2[3];
		  }
	  }
   }

}


void C3DView::Draw3DObject(void)
{
    int k, Ptid;

    
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
    glEnable(GL_COLOR_MATERIAL);
	glPolygonMode(GL_FRONT,GL_FILL);
	glPolygonMode(GL_BACK,GL_FILL);

    glShadeModel(GL_SMOOTH);
     

    glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
    glTranslatef(m_x, m_y, m_z);
	glRotatef(m_xa, 1.0, 0.0, 0.0);
	glRotatef(m_ya, 0.0, 1.0, 0.0);
	glRotatef(m_za, 0.0, 0.0, 1.0);
	
	for(int i = 0; i < ROW; i++)
    {
	   for(int j = 0; j < COL; j++)
	   { 
          Ptid = i * COL + j;
	      glBegin(GL_QUADS);
	          
		  glColor4ubv(m_Vertex[Ptid].m_vColor);
                 
	      k = i * (COL+1) + j;
	      glNormal3fv(m_Point[k].m_vNormal); 
		  glVertex3fv(m_Point[k].m_vPoint);
              
		  k = i * (COL+1) + j + 1;
    	  glNormal3fv(m_Point[k].m_vNormal); 
		  glVertex3fv(m_Point[k].m_vPoint);

		  k = (i + 1) * (COL+1) + j + 1;
   		  glNormal3fv(m_Point[k].m_vNormal); 
		  glVertex3fv(m_Point[k].m_vPoint);

		  k = (i + 1) * (COL+1) + j ;
		  glNormal3fv(m_Point[k].m_vNormal); 
		  glVertex3fv(m_Point[k].m_vPoint);

		  glEnd();
	   }
	}

	glRotatef(-1.0 * m_za, 0.0, 0.0, 1.0);
	glRotatef(-1.0 * m_ya, 0.0, 1.0, 0.0);
	glRotatef(-1.0 * m_xa, 1.0, 0.0, 0.0);
    glTranslatef(-1.0 * m_x, -1.0 * m_y, -1.0 * m_z);
}

void C3DView::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
	
	// TODO: Add your message handler code here
    if(m_bActive)
    {
	   if(!m_bTimer)
	   {
           SetTimer(m_iTimer, 1, NULL);
		   m_bTimer = TRUE;
	   }
	}
}

void C3DView::OnKillFocus(CWnd* pNewWnd) 
{
	CView::OnKillFocus(pNewWnd);
	
	// TODO: Add your message handler code here
    if(m_bActive)
    {
	   if(m_bTimer)
	   {
           KillTimer(m_iTimer);
		   m_bTimer = FALSE;
	   }
	}
	
}
